package com.ampos.fluttersound

import android.Manifest
import android.content.pm.PackageManager
import android.os.Build
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry

class AmposFlutterSoundPlugin : BaseFlutterSoundPlugin() {

    override fun getDefaultPath(): String =
        reg.context().cacheDir.absolutePath.plus("/audio_record.m4a")

    override fun requestPermission(result: MethodChannel.Result?): Boolean {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (reg.activity().checkSelfPermission(Manifest.permission.RECORD_AUDIO) != PackageManager.PERMISSION_GRANTED) {
                reg.activity().requestPermissions(
                    arrayOf(
                        Manifest.permission.RECORD_AUDIO
                    ), 0
                )
                result?.error(
                    TAG,
                    "NO PERMISSION GRANTED",
                    Manifest.permission.RECORD_AUDIO
                )
                return true
            }
        }
        return false
    }

    companion object {
        @JvmStatic
        fun registerWith(registrar: PluginRegistry.Registrar) {
            channel = MethodChannel(registrar.messenger(), "flutter_sound")
            channel.setMethodCallHandler(AmposFlutterSoundPlugin())
            reg = registrar
        }
    }
}